extends Area1D


@export var animation: GradientTexture1D


var speed: float = 1.0


var _progress: float = 0.0
var _animation_image: Image
var _animation_image_size: float


func _ready() -> void:
	_animation_image = animation.get_image()
	_animation_image_size = float(_animation_image.get_width())


func _physics_process(delta: float) -> void:
	_progress += speed * delta
	if _progress > 1.0:
		_kill()
		_progress -= 1.0
	modulate = _get_color(_progress)


func _get_color(t: float) -> Color:
	return _animation_image.get_pixel(int(t * _animation_image_size), 0)


func _kill() -> void:
	for body in get_overlapping_bodies():
		if body is Player:
			body.die()
