extends Node1D


const _GENERATION_OFFSET: float = 1000.0
const _PLATTFORM_SCENE: PackedScene = preload("res://level/platform.tscn")
const _ENEMY_SCENE: PackedScene = preload("res://enemy/enemy.tscn")


@export var player: Player


var _current_pos = 0.0


func _ready() -> void:
	randomize()


func _physics_process(_delta: float) -> void:
	while _current_pos < player.position + _GENERATION_OFFSET:
		_current_pos += randf_range(128.0, 200.0)
		var enemy = _ENEMY_SCENE.instantiate()
		enemy.position = _current_pos
		enemy._progress = randf()
		add_child(enemy)
		_current_pos += randf_range(64.0, 128.0)
		var plattform = _PLATTFORM_SCENE.instantiate()
		plattform.position = _current_pos
		plattform.player = player
		add_child(plattform)
	
	if Input.is_action_just_pressed("restart"):
		get_tree().reload_current_scene()
