class_name Player
extends KinematicBody1D


const _GRAVITY: float = 500.0
const _JUMP_FORCE: float = 400.0
const _JUMP_COUNT: int = 2


var momentum: float
var jumps_remaining: int = 0
var dead = false


func _physics_process(delta: float) -> void:
	if dead:
		return
	momentum -= delta * _GRAVITY
	if Input.is_action_just_pressed("jump"):
		if jumps_remaining != 0:
			momentum = _JUMP_FORCE
			jumps_remaining -= 1
	var result: float = move_and_collide(momentum * delta)
	if result != 0.0:
		jumps_remaining = _JUMP_COUNT


func die() -> void:
	dead = true
	hide()
